<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="chrome=1" />
<meta http-equiv="cache-control" content="max-age=0" />
<meta http-equiv="cache-control" content="no-cache" />
<meta http-equiv="expires" content="0" />
<meta http-equiv="expires" content="Tue, 01 Jan 1980 1:00:00 GMT" />
<meta http-equiv="pragma" content="no-cache" />
<title>EjsS Library</title>
<link rel="stylesheet" href="css/library.css" type="text/css" />
<link rel="shortcut icon" href="images/icons/logo.png" />
<link rel="stylesheet" href="js/jstree/themes/default/style.min.css" />
<script src="http://code.jquery.com/jquery-1.10.2.js"></script>
<script src="js/jstree/jstree.min.js"></script>
<script src="js/osp.js"></script>
<script>
	var arrayCollection = [];
	var refreshed = true;
	
	// funciones para mostrar en webview
	function loadUrl(url) {
		$('#webview').attr("src", url);
	}
	
	function loadData(data) {
		$('#webview').attr("src", "data:text/html;charset=utf-8," + escape(data));
	}
	
	function loadTreeInfo(node) {
    	// create content (list of children)
    	var content = "<h4>" + node.text + "</h4>";
    	content += "<ul>";
    	for(var c in node.children) {
    		content += "<li>" + libraryComPADRE.getNameFromId(node.children[c])  + "</li>";
    	}
    	content += "</ul>";
		$('#webview').attr("src", "data:text/html;charset=utf-8," + escape(content));
	}
	
	function addElementToTree(selectedNode,collection) {
		var json = collection.toJSON();
		json.splice(0, 1);
		arrayCollection = arrayCollection.concat(json);
	}
	
	function createTree() {
		var messages = document.querySelector('#messages');
		
		// init buttons 	
    	var importButton = document.querySelector('#import');
    	importButton.disabled = true;
    	
    	var closeButton = document.querySelector('#close');
		closeButton.onclick = function() {
			// close window
			var librariesNav = window.parent.document.querySelector('#libraries-nav');
    		librariesNav.classList.remove('show');
    		librariesNav.innerHTML = '';
		};

   		// info
    	loadData("Loading - Please wait")
		
		// init tree
		$('#jstree_div').jstree({'core': {'data': arrayCollection},
			  "types" : {
				    "file" : {
				      "icon" : "images/icons/file16.png"
				    },
				    "folder" : {
				      "icon" : "images/icons/folder16.png"
				    },
				    "default" : {
				      "icon" : "images/icons/folder16.png"
				    }
				 },
			"plugins": ["types","wholerow"]});		

		// gestión de cambios
		$('#jstree_div').on("changed.jstree", function (e, data) {
			// init buttons
	    	importButton.disabled = true;
			
	        // select node
	        var selectedNode = data.node;
			if(selectedNode) { 
				var data = selectedNode.data;						       
								
				if (data.htmlPath && data.htmlPath.length > 0) {
					loadUrl(data.htmlPath);
				} else {
					var content;
					if (selectedNode.children.length == 0 && data.type == LibraryResource.COLLECTION_TYPE) { 
		        		loadData("<p> The resources for this collection are been downloaded automatically.</p>");
		        		
			       		// directory not downloaded
			        	if(data.description.indexOf(LibraryComPADRE.Description_DoubleClick) > -1) {

			    			// download resources
			    			if(refreshed) {
			    				refreshed = false;
								cloudComPADREConnection(data.target, selectedNode, false, 
									function(collection) {
										addElementToTree(selectedNode,collection);								
										resfreshJSTree();
										refreshed = true;
									});
							}
			        	}									        
			        } else {
			        	if (selectedNode.children.length > 0)
			        		loadTreeInfo(selectedNode);
			        	else {
			        		loadData(data.description);
			        		
			        		// active buttons
					    	importButton.disabled = false;
			        		
			        		importButton.onclick = function() {
			        			// window.open(selectedNode.data.target); 
			        			
								messages.textContent = 'Download in progress.';
			        			window.parent.downloadComPADREFile(selectedNode.data.target, 
			        				function() {
			        					messages.textContent = '';
			        					alert('Model added to your EjsS Reader.');
			        				}, 
			        				function(e) {
			        					messages.textContent = '';
			        					alert('Error: ' + e);
			        				});
			        		};
			        	}
			        }
				}
  			}  			  			
		});
		
		// connection ComPadre
		cloudComPADREConnection(null, null, true, 
			function(collection) { 
				arrayCollection = collection.toJSON();
				resfreshJSTree();	
				loadData("<h1>OSP Digital Library Models</h1>" +
					"EjsS models within the AAPT-ComPADRE OSP Collection are organized by subject" +
					" in the table of contents tree displayed in the left hand side of this display." +
					"Click on a subject folder icon to browse the available models. " +
					"A description of each model, including the model author, is displayed in the item panel. ");			
			});				
	}
		        		
    function resfreshJSTree() {
        $('#jstree_div').jstree(true).settings.core.data = arrayCollection;
        $('#jstree_div').jstree(true).refresh();
    }
    	
 	$(function () { 		
 		createTree();
 	});
 		
</script>
</head>
<body>
<!--
<div id="container">
<header>
  <div><img src="images/icons/logo.png" alt="EjsS Library" title="EjsS Library"></div>
  <h1>EjsS Library - Library for Easy Java/Javascript Simulations</h1>
</header>
<section>
-->
  <div id="content">
   <div id="jstree_div"></div>
   <div id="webview_div">
   	<iframe id="webview"></iframe>
   	<div>
  	 <button id="import">Import Model</button>
  	 <button id="close">Close</button>
  	 <div id="messages" class="message"></div>
  	</div>
   </div>
  </div>
<!--
</section>
<footer>
  <span>Created by <a href="http://webs.um.es/fgarcia">Felix J. Garcia</a> for <a href="http://www.um.es/fem/EjsWiki/">Easy Java/Javascript Simulations</a></span>	
</footer>
</div>
-->
</body>
</html>
